<div class="row text-center d-none d-lg-flex">
  <div class="col-lg-4">
    <div class="btn-group">
      <div
          class="btn btn-primary"
          mwlCalendarPreviousView
          [view]="view"
          [(viewDate)]="viewDate"
          (viewDateChange)="closeOpenMonthViewDay()"
      >
        <i class="fas fa-chevron-left"></i>
      </div>
      <div
          class="btn btn-outline-primary"
          mwlCalendarToday
          [(viewDate)]="viewDate"
      >
        Heute
      </div>
      <div
          class="btn btn-primary"
          mwlCalendarNextView
          [view]="view"
          [(viewDate)]="viewDate"
          (viewDateChange)="closeOpenMonthViewDay()"
      >
        <i class="fas fa-chevron-right"></i>
      </div>
    </div>
  </div>
  <div class="col-lg-4">
    <h3>{{ viewDate | calendarDate:(view + 'ViewTitle' + headerView):'de' }}</h3>
  </div>
  <div class="col-lg-4">
    <div class="btn-group">
      <div
          class="btn btn-primary"
          (click)="setView(CalendarView.Month)"
          [class.active]="view === CalendarView.Month"
      >
        Monat
      </div>
      <div
          class="btn btn-primary"
          (click)="setView(CalendarView.Week)"
          [class.active]="view === CalendarView.Week"
      >
        Woche
      </div>
      <div
          class="btn btn-primary"
          (click)="setView(CalendarView.Day)"
          [class.active]="view === CalendarView.Day"
      >
        Tag
      </div>
    </div>
  </div>
</div>
<div class="row text-center d-lg-none d-flex">
  <div class="col-4">
    <div class="btn-group btn-group-sm">
      <div
          class="btn btn-primary btn-sm"
          mwlCalendarPreviousView
          [view]="view"
          [(viewDate)]="viewDate"
          (viewDateChange)="closeOpenMonthViewDay()"
      >
        <i class="fas fa-chevron-left"></i>
      </div>
      <div
          class="btn btn-secondary btn-sm"
          mwlCalendarToday
          [(viewDate)]="viewDate"
      >
        Heute
      </div>
      <div
          class="btn btn-primary btn-sm"
          mwlCalendarNextView
          [view]="view"
          [(viewDate)]="viewDate"
          (viewDateChange)="closeOpenMonthViewDay()"
      >
        <i class="fas fa-chevron-right"></i>
      </div>
    </div>
  </div>
  <div class="col-4 force-inline">
    <h5>{{ viewDate | calendarDate:(view + 'ViewTitle' + headerView):'de' }}</h5>
  </div>
  <div class="col-4">
    <div class="btn-group btn-group-sm">
      <div class="btn btn-info btn-sm" [outsideClick]="true"
           placement="left"
           [popover]="calendarConfig" popoverTitle="Konfiguration">
        <i class="fas fa-cog"></i>
      </div>
      <div
          class="btn btn-primary btn-sm"
          (click)="setView(CalendarView.Month)"
          [class.active]="view === CalendarView.Month"
      >
        M
      </div>
      <div
          class="btn btn-primary btn-sm"
          (click)="setView(CalendarView.Week)"
          [class.active]="view === CalendarView.Week"
      >
        W
      </div>
      <div
          class="btn btn-primary btn-sm"
          (click)="setView(CalendarView.Day)"
          [class.active]="view === CalendarView.Day"
      >
        T
      </div>
    </div>
  </div>
</div>


<div class="row mt-lg-3">
  <div class="col-lg-9 col-md-12">
    <div *ngIf="showEvents">
      <div [ngSwitch]="view">
        <mwl-calendar-month-view
            *ngSwitchCase="CalendarView.Month"
            [viewDate]="viewDate"
            [events]="showEvents"
            [refresh]="refresh"
            [activeDayIsOpen]="activeDayIsOpen"
            (dayClicked)="dayClicked($event.day)"
            (eventClicked)="handleEvent('Clicked', $event.event)"
            (beforeViewRender)="beforeMonthViewRender($event)"
            [weekStartsOn]="1"
            [headerTemplate]="monthHeaderTemplate"
            [cellTemplate]="cellTemplate"
        >
        </mwl-calendar-month-view>
        <mwl-calendar-week-view
            *ngSwitchCase="CalendarView.Week"
            [viewDate]="viewDate"
            [events]="showEvents"
            [refresh]="refresh"
            dayStartHour="8"
            dayEndHour="22"
            (eventClicked)="handleEvent('Clicked',$event.event)"
            [weekStartsOn]="1"
            [headerTemplate]="weekHeaderTemplate"
        >
        </mwl-calendar-week-view>
        <mwl-calendar-day-view
            *ngSwitchCase="CalendarView.Day"
            [viewDate]="viewDate"
            [events]="showEvents"
            [refresh]="refresh"
            dayStartHour="8"
            dayEndHour="22"
            (eventClicked)="handleEvent('Clicked',$event.event)"
        >
        </mwl-calendar-day-view>
      </div>
    </div>
  </div>
  <div class="col-lg-3 d-none d-lg-block">
    <div class="card">
      <ng-template [ngTemplateOutlet]="calendarConfig"></ng-template>
    </div>
  </div>
</div>

<ng-template #cellTemplate let-day="day" let-locale="locale">
  <div class="cal-cell-top">
    <span class="cal-day-number">
      {{ day.date | calendarDate:'monthViewDayNumber':locale }}
    </span>
  </div>
  <div class="cell-totals">
    <span
        *ngFor="let group of day.eventGroups"
        class="badge badge-{{ group[0] }} mr-1 mr-md-2"
    >
      {{ group[1].length }}
    </span>
  </div>
</ng-template>


<ng-template
  #monthHeaderTemplate
  let-days="days"
  let-locale="locale"
  let-trackByWeekDayHeaderDate="trackByWeekDayHeaderDate"
>
  <div class="cal-cell-row cal-header" role="row">
    <div
        class="cal-cell"
        *ngFor="let day of days; trackBy: trackByWeekDayHeaderDate"
        [class.cal-past]="day.isPast"
        [class.cal-today]="day.isToday"
        [class.cal-future]="day.isFuture"
        [class.cal-weekend]="day.isWeekend"
        [ngClass]="day.cssClass"
        tabindex="0"
        role="columnheader"
    >
      {{ day.date | calendarDate: 'monthViewColumnHeader' + headerView:locale }}
    </div>
  </div>
</ng-template>

<ng-template
  #weekHeaderTemplate
  let-days="days"
  let-locale="locale"
  let-dayHeaderClicked="dayHeaderClicked"
  let-eventDropped="eventDropped"
  let-trackByWeekDayHeaderDate="trackByWeekDayHeaderDate"
  let-dragEnter="dragEnter"
>
  <div class="cal-day-headers" role="row">
    <div
        class="cal-header"
        *ngFor="let day of days; trackBy: trackByWeekDayHeaderDate"
        [class.cal-past]="day.isPast"
        [class.cal-today]="day.isToday"
        [class.cal-future]="day.isFuture"
        [class.cal-weekend]="day.isWeekend"
        [ngClass]="day.cssClass"
        (mwlClick)="dayHeaderClicked.emit({ day: day, sourceEvent: $event })"
        tabindex="0"
        role="columnheader"
    >
      <b>{{ day.date | calendarDate: 'weekViewColumnHeader' + headerView:locale }}</b
      ><br />
      <span class="d-none d-md-block">{{
        day.date | calendarDate: 'weekViewColumnSubHeader':locale
        }}</span>
    </div>
  </div>
</ng-template>

<ng-template #calendarConfig>
  <div class="card-heading">
    <h5>Projekte</h5>
  </div>
  <div class="card-body">
    <ng-container *ngFor="let filter of calendarProjectFilter">
      <div class="custom-control custom-checkbox">
        <input type="checkbox" class="custom-control-input" id="{{filter.project.id}}Check" [(ngModel)]="filter.show" (change)="filterCalendar()">
        <label class="custom-control-label" for="{{filter.project.id}}Check" style="color: {{filter.project.color.primary}}">{{filter.project.name}}</label>
      </div>
    </ng-container>
    <hr>
    <div class="custom-control custom-checkbox">
      <input type="checkbox" class="custom-control-input" id="announcedCheck" [(ngModel)]="calendarFilter.announced" (change)="filterCalendar()">
      <label class="custom-control-label" for="announcedCheck">Angemeldet</label>
    </div>
    <div class="custom-control custom-checkbox">
      <input type="checkbox" class="custom-control-input" id="unannouncedCheck" [(ngModel)]="calendarFilter.unannounced" (change)="filterCalendar()">
      <label class="custom-control-label" for="unannouncedCheck">Abgemeldet</label>
    </div>
    <div class="custom-control custom-checkbox">
      <input type="checkbox" class="custom-control-input" id="noResponseCheck" [(ngModel)]="calendarFilter.noResponse" (change)="filterCalendar()">
      <label class="custom-control-label" for="noResponseCheck">Ohne Rückmeldung</label>
    </div>
  </div>
</ng-template>